<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="使用场景" prop="useScene">
      <el-select v-model="queryParams.useScene" placeholder="请选择使用场景">
        <el-option
          v-for="item in options"
          :key="item.value"
          :label="item.label"
          :value="item.value">
        </el-option>
      </el-select>
    </el-form-item>
      <el-form-item label="元器件编号" prop="componentId" label-width="200px">
<!--        <el-input-->
<!--          v-model="queryParams.componentId"-->
<!--          placeholder="请输入元器件编号"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->

        <el-select v-model="queryParams.componentId" filterable placeholder="请输入元器件编号">
          <el-option
            v-for="item in componentInfo"
            :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="评分" prop="mark">
        <el-input
          v-model="queryParams.mark"
          placeholder="请输入评分"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
<!--      <el-form-item label="使用场景" prop="usedBy">-->
<!--        <el-input-->
<!--          v-model="queryParams.usedBy"-->
<!--          placeholder="请输入使用场景"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="primary"-->
<!--          plain-->
<!--          icon="el-icon-plus"-->
<!--          size="mini"-->
<!--          @click="handleAdd"-->
<!--          v-hasPermi="['biz:evaluation:add']"-->
<!--        >新增</el-button>-->
<!--      </el-col>-->
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="success"-->
<!--          plain-->
<!--          icon="el-icon-edit"-->
<!--          size="mini"-->
<!--          :disabled="single"-->
<!--          @click="handleUpdate"-->
<!--          v-hasPermi="['biz:evaluation:edit']"-->
<!--        >修改</el-button>-->
<!--      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['biz:evaluation:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['biz:evaluation:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="evaluationList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="编号" align="center" prop="id" />-->
      <el-table-column label="查询条件" align="center" prop="searchCondition" :show-overflow-tooltip="true"/>
      <el-table-column label="元器件编号" align="center" prop="componentId" :show-overflow-tooltip="true"/>
      <el-table-column label="元器件名称" align="center" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span>{{ getComponentName(scope.row.componentId) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="元器件型号规格" align="center" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span>{{ getComponentModel(scope.row.componentId) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="元器件质量等级" align="center" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span>{{getComponentQuality(scope.row.componentId)}}</span>
        </template>
      </el-table-column>
      <el-table-column label="评分" align="center" prop="mark" />
      <el-table-column label="应用设备" align="center" prop="usedBy" :show-overflow-tooltip="true"/>
      <el-table-column label="使用场景" align="center" prop = "useScene" :show-overflow-tooltip="true"/>
      <el-table-column label="备注" align="center" prop="remark" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['biz:evaluation:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['biz:evaluation:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改评价对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form  style="border:1px solid #C0C0C0;padding: 5px;margin: auto" ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="查询条件" prop="searchCondition">
          <el-input v-model="form.searchCondition" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="元器件编号" prop="componentId">
          <el-select v-model="form.componentId" filterable placeholder="请输入元器件编号">
          <el-option
            v-for="item in componentInfo"
            :value="item.id">
          </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="评分" prop="mark">
          <el-input v-model="form.mark" placeholder="请输入评分" />
        </el-form-item>
        <el-form-item label="应用设备" prop="usedBy">
          <el-input v-model="form.usedBy" placeholder="请输入应用设备" />
        </el-form-item>
        <el-form-item label="使用场景" prop="useScene">
          <el-select v-model="form.useScene" placeholder="请选择使用场景">
            <el-option
              v-for="item in options"
              :key="item.value"
              :label="item.label"
              :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listEvaluation, getEvaluation, delEvaluation, addEvaluation, updateEvaluation,getall } from "@/api/biz/evaluation";

export default {
  name: "Evaluation",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 评价表格数据
      evaluationList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        searchCondition: null,
        componentId: null,
        mark: null,
        usedBy: null,
        useScene:null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      componentInfo:[],
      evaluationMap : new Map(),
      dataLoaded:false,
      options:[
        {
          value: '质量最优',
          label: '质量最优'
        }, {
          value: '成本最优',
          label: '成本最优'
        }, {
          value: '供货周期最优',
          label: '供货周期最优'
        }, {
          value: '供货量最优',
          label: '供货量最优'
        }
      ],
    };
  },
  async created() {
    try {
      this.componentInfo = await getall();
      // console.log(this.componentInfo);
    } catch (error) {
      console.error("Error fetching component info:", error);
    }
    this.getList();
  },
  methods: {
    /** 查询评价列表 */
    getList() {
      this.loading = true;
      listEvaluation(this.queryParams).then(response => {
        this.evaluationList = response.rows;
        this.total = response.total;
        for(let one of this.componentInfo){
          // this.$set(this.evaluationMap,'key',one.id)
          // this.$set(this.evaluationMap, 'value',[one.componentName,one.componentModel,one.qualityGrade] )
          this.evaluationMap.set(one.id.toString(), [one.componentName,one.componentModel,one.qualityGrade])

        }
        // console.log(this.evaluationMap)
        this.dataLoaded = true;
        this.loading = false;
      });
    },
    getComponentName(componentId) {

      let strid = componentId.toString()

      if (this.evaluationMap.has(strid)) {

        return this.evaluationMap.get(strid)[0];
      } else {
        return "Data not available";
      }
    },
    getComponentModel(componentId) {

      let strid = componentId.toString()

      if (this.evaluationMap.has(strid)) {
        return this.evaluationMap.get(strid)[1];
      } else {
        return "Data not available";
      }
    },
    getComponentQuality(componentId) {

      let strid = componentId.toString()

      if (this.evaluationMap.has(strid)) {
        return this.evaluationMap.get(strid)[2];
      } else {
        return "Data not available";
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        searchCondition: null,
        componentId: null,
        mark: null,
        usedBy: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
        useScene:null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    // handleAdd() {
    //   this.reset();
    //   this.open = true;
    //   this.title = "添加评价";
    // },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getEvaluation(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改评价";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateEvaluation(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addEvaluation(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除评价编号为"' + ids + '"的数据项？').then(function() {
        return delEvaluation(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('biz/evaluation/export', {
        ...this.queryParams
      }, `evaluation_${new Date().getTime()}.xlsx`)
    },



  }
};
</script>
